
;CodeVisionAVR C Compiler V1.25.3 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Medium
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1200 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : No
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __GETBRPF
	OUT  RAMPZ,R22
	ELPM R@0,Z
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
	LDI  R29,BYTE3(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	OUT  RAMPZ,R29
	ELPM R24,Z+
	ELPM R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	ELPM R26,Z+
	ELPM R27,Z+
	ELPM R0,Z+
	ELPM R1,Z+
	ELPM R28,Z+
	ELPM R29,Z+
	MOVW R22,R30
	IN   R29,RAMPZ
	MOVW R30,R0
	OUT  RAMPZ,R28
__GLOBAL_INI_LOOP:
	ELPM R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x5B0)
	LDI  R29,HIGH(0x5B0)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x5B0
;       1 // ======================== Atmega128 ؽƮ LCD α׷ =====================
;       2 //  CPU : ATmega128-16M - ؽƮ LCD(4*20)
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega128.h>							// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 #include <math.h>
;      17 #include <delay.h>
;      18 
;      19 //  
;      20 #include "cpusetup.inc"							// cpu  ͷƮ  ƾ
;      21 // =================================== CPUʱȭ ͷƮ ===================
;      22 //      : CPU  ϰ ͷƮ  ƾ .
;      23 // ----------------------------------------------------------------------------
;      24 //   
;      25 #define RXB8 1
;      26 #define TXB8 0
;      27 #define UPE 2
;      28 #define OVR 3
;      29 #define FE 4
;      30 #define UDRE 5
;      31 #define RXC 7
;      32 
;      33 #define FRAMING_ERROR (1<<FE)
;      34 #define PARITY_ERROR (1<<UPE)
;      35 #define DATA_OVERRUN (1<<OVR)
;      36 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      37 #define RX_COMPLETE (1<<RXC)
;      38 
;      39 // Լ 
;      40 int putchar_0(char data);					// COM1 ۽
;      41 int getchar_0(void);						// COM1 
;      42 
;      43 //  
;      44 char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
;      45 
;      46 // ===================================== CPUʱȭ ============================
;      47 // [μ] void
;      48 // ----------------------------------------------------------------------------
;      49 void cpu_setup(void)
;      50 {

	.CSEG
_cpu_setup:
;      51 // PortA 
;      52 // LCD_D[0..7] : LCD Data Bus
;      53 	PORTA=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;      54 	DDRA=0x00;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;      55 
;      56 // PortC 
;      57 // LCD_D[8..15] : LCD Data Bus(color lcd)
;      58 // PortC.0 : LCD_CS1
;      59 // PortC.1 : LCD_CS2
;      60 	PORTC=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0x15,R30
;      61 	DDRC=0x03;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(3)
	OUT  0x14,R30
;      62 
;      63 // PortE 
;      64 // PortE.3(OUT) : LCD DIR
;      65 // PortE.4(OUT) : LCD E
;      66 // PortE.5(OUT) : LCD RS
;      67 // PortE.6(OUT) : GLCD/CLCD Reset
;      68 // PortE.7(IN)  : TSC2003 Interrupt PULL UP(external)
;      69 	PORTE=0x40;						// Ʈ  reg
	LDI  R30,LOW(64)
	OUT  0x3,R30
;      70 	DDRE=0x78;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(120)
	OUT  0x2,R30
;      71 
;      72 // PortG 
;      73 // PortG.0(OUT) : LCD R/W,CLCD_WR
;      74 // PortG.1(OUT) : LCD RD
;      75 // PortG.2(OUT) : LCD CS
;      76 	PORTG=0x07;						// Ʈ  reg
	LDI  R30,LOW(7)
	STS  101,R30
;      77 	DDRG=0x07;                                              // Ʈ  reg(0Է,1)
	STS  100,R30
;      78 
;      79 //  ʱȭ(COM1)
;      80 // 19200Bps, 8Data, 1 Stop, No Parity
;      81 	UCSR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;      82 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;      83 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;      84 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;      85 	UBRR0L=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;      86 
;      87 // External SRAM page configuration:
;      88 //              -              / 0000h - FFFFh
;      89 // Lower page wait state(s): None
;      90 // Upper page wait state(s): 1r/w
;      91 //	MCUCR=0xc0;
;      92 //	XMCRA=0x02;
;      93 
;      94 // Analog Comparator 
;      95 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;      96 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;      97 
;      98 // Global enable interrupts
;      99 #asm("sei")
	sei
;     100 }
	RET
;     101 
;     102 // =============================== COM1 ͷƮ ===========================
;     103 // [μ] void
;     104 // ----------------------------------------------------------------------------
;     105 #pragma savereg-
;     106 interrupt [USART0_RXC] void uart0_rx_isr(void)
;     107 {
_uart0_rx_isr:
;     108 char status,data;
;     109 #asm
;     110 	push r26
	push r26
;     111 	push r27
	push r27
;     112 	push r30
	push r30
;     113 	push r31
	push r31
;     114 	in   r26,sreg
	in   r26,sreg
;     115 	push r26
	push r26
;     116 #endasm
;     117 
;     118 	status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     119 	data=UDR0;
	IN   R16,12
;     120 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     121 		com1_rx_data = data;
	MOV  R5,R16
;     122 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     123 	}
;     124 
;     125 #asm
_0x3:
;     126 	pop  r26
	pop  r26
;     127 	out  sreg,r26
	out  sreg,r26
;     128 	pop  r31
	pop  r31
;     129 	pop  r30
	pop  r30
;     130 	pop  r27
	pop  r27
;     131 	pop  r26
	pop  r26
;     132 #endasm
;     133 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     134 #pragma savereg+
;     135 
;     136 #include "textlcd.inc"							// Text LCD
;     137 // ============================ ؽƮ LCD  α׷ ======================
;     138 //      : 4*20 LCD
;     139 // ----------------------------------------------------------------------------
;     140 // LCD  
;     141 #define	SCREEN1		0
;     142 #define	SCREEN2		1
;     143 
;     144 #define	OFF		0
;     145 #define	ON		1
;     146 
;     147 // Լ 
;     148 void Clrscr(void);						// ȭ 
;     149 
;     150 void Cursor_Set(char sts);					// Ŀ  
;     151 void Gotoxyt(char x, char y);					// ؽƮ ǥ
;     152 
;     153 void Putch(char data);						// 1 ǥ
;     154 void Putchxyt(char x, char y,char data);			// ؽƮ ǥ  ǥ
;     155 
;     156 // SRAM  ǥ
;     157 void Puts(char stbuf[]);					// LCD ڿ 
;     158 void Putsxyt(char x, char y,char dbuf[]);			// ؽƮ ǥ ڿ ǥ
;     159 // FLASH ޸ ڿ ǥ
;     160 void Puts_f(char flash stbuf[]);				// LCD ڿ(FLASH) 
;     161 void Putsxyt_f(char x, char y,char flash dbuf[]);		// ؽƮ ǥ ڿ(FLASH) ǥ
;     162 
;     163 void LCD_Init(void);						// GLCD Init
;     164 void LCD_Busy(void);						// LCD Busy Check
;     165 void LCD_Command(unsigned char uch);				// COMMAND Write
;     166 void LCD_Dwrite(unsigned char uch);				// DATA Write
;     167 unsigned char LCD_Dread(void);					// DATA 
;     168 
;     169 //  
;     170 
;     171 // =========================== ؽƮ Ŀ ġ  ============================
;     172 // [μ] char sts
;     173 // Item1: Ŀ (0,(OFF),1(ON))
;     174 // Item2: Ŀ ǥ ġ(SCREEN0,SCREEN1)
;     175 /// ----------------------------------------------------------------------------
;     176 void Cursor_Set(char sts)
;     177 {
_Cursor_Set:
;     178 	if(sts == OFF) LCD_Command(0x0c);			// CURSOR OFF/BLINK OFF
;	sts -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x4
	LDI  R30,LOW(12)
	RJMP _0xB3
;     179 	else LCD_Command(0x0f);					// CURSOR ON/BLINK ON(0x0e)
_0x4:
	LDI  R30,LOW(15)
_0xB3:
	ST   -Y,R30
	RCALL _LCD_Command
;     180 }
	RJMP _0xB2
;     181 
;     182 // ================================ ȭ Ұ ==================================
;     183 // [μ] void
;     184 /// ----------------------------------------------------------------------------
;     185 void Clrscr(void)
;     186 {
_Clrscr:
;     187 	LCD_Command(0x01);					// ALL CLEAR
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_Command
;     188 }
	RET
;     189 
;     190 // =========================== ؽƮ Ŀ ġ  ============================
;     191 // [μ] char x,char y
;     192 // Item1: ǥ xǥ(1-20)
;     193 // Item2: ǥ yǥ(1-4)
;     194 /// ----------------------------------------------------------------------------
;     195 void Gotoxyt(char x, char y)
;     196 {
_Gotoxyt:
;     197 char xx = x-1,yy = y-1;
;     198 
;     199 	LCD_Busy();
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+3
;	y -> Y+2
;	xx -> R17
;	yy -> R16
	LDD  R30,Y+3
	SUBI R30,LOW(1)
	MOV  R17,R30
	LDD  R30,Y+2
	SUBI R30,LOW(1)
	MOV  R16,R30
	RCALL _LCD_Busy
;     200 	switch(yy){
	MOV  R30,R16
;     201 		case 0: LCD_Command(0x80+xx); break;
	CPI  R30,0
	BRNE _0x9
	MOV  R30,R17
	SUBI R30,-LOW(128)
	RJMP _0xB4
;     202 		case 1: LCD_Command(0xc0+xx); break;
_0x9:
	CPI  R30,LOW(0x1)
	BRNE _0xA
	MOV  R30,R17
	SUBI R30,-LOW(192)
	RJMP _0xB4
;     203 		case 2: LCD_Command(0x94+xx); break;
_0xA:
	CPI  R30,LOW(0x2)
	BRNE _0xB
	MOV  R30,R17
	SUBI R30,-LOW(148)
	RJMP _0xB4
;     204 		case 3: LCD_Command(0xd4+xx); break;
_0xB:
	CPI  R30,LOW(0x3)
	BRNE _0x8
	MOV  R30,R17
	SUBI R30,-LOW(212)
_0xB4:
	ST   -Y,R30
	RCALL _LCD_Command
;     205 	}
_0x8:
;     206 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0xB0
;     207 
;     208 // ==================================  ǥ ================================
;     209 // [μ] char data
;     210 // Item1: ǥ ڿ
;     211 /// ----------------------------------------------------------------------------
;     212 void Putch(char data)
;     213 {
_Putch:
;     214 	LCD_Dwrite(data);					//  ǥ
;	data -> Y+0
	LD   R30,Y
	ST   -Y,R30
	RCALL _LCD_Dwrite
;     215 }
_0xB2:
	ADIW R28,1
	RET
;     216 
;     217 // ============================  ġ  ǥ ===========================
;     218 // [μ] char x,char y,char data
;     219 // Item1: ǥ xǥ(1-20)
;     220 // Item2: ǥ yǥ(1-4)
;     221 // Item3: ǥ ڿ
;     222 /// ----------------------------------------------------------------------------
;     223 void Putchxyt(char x, char y,char data)
;     224 {
_Putchxyt:
;     225 	Gotoxyt(x,y);						// ǥ 
;	x -> Y+2
;	y -> Y+1
;	data -> Y+0
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _Gotoxyt
;     226 	LCD_Dwrite(data);					//  ǥ
	LD   R30,Y
	ST   -Y,R30
	RCALL _LCD_Dwrite
;     227 }
	ADIW R28,3
	RET
;     228 
;     229 // ============================= LCD1 ڿ  ===========================
;     230 // [μ] char str[]
;     231 // Item1: ɾ
;     232 // ----------------------------------------------------------------------------
;     233 void Puts(char stbuf[])
;     234 {
_Puts:
;     235 char *pstr = 0;
;     236 
;     237 	pstr = stbuf;
	ST   -Y,R17
	ST   -Y,R16
;	*stbuf -> Y+2
;	*pstr -> R16,R17
	LDI  R16,LOW(0x00)
	LDI  R17,HIGH(0x00)
	__GETWRS 16,17,2
;     238 	while(*pstr) LCD_Dwrite(*pstr++);			// ڿ 
_0xD:
	MOVW R26,R16
	LD   R30,X
	CPI  R30,0
	BREQ _0xF
	__ADDWRN 16,17,1
	ST   -Y,R30
	RCALL _LCD_Dwrite
;     239 }
	RJMP _0xD
_0xF:
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0xB0
;     240 
;     241 // ========================== LCD1 FLASH ڿ  ========================
;     242 // [μ] char flash str[]
;     243 // Item1: ɾ
;     244 // ----------------------------------------------------------------------------
;     245 void Puts_f(char flash stbuf[])
;     246 {
_Puts_f:
;     247 	while(*stbuf) LCD_Dwrite(*stbuf++);			// ڿ 
;	*stbuf -> Y+0
_0x10:
	CALL SUBOPT_0x0
	__GETBRPF 30
	CPI  R30,0
	BREQ _0x12
	CALL SUBOPT_0x1
;     248 }
	RJMP _0x10
_0x12:
	RJMP _0xB0
;     249 
;     250 // ===========================  ġ ڿ ǥ =========================
;     251 // [μ] char x,char y,char dbuf[]
;     252 // Item1: ǥ xǥ(1-20)
;     253 // Item2: ǥ yǥ(1-4)
;     254 // Item3: ǥ ڿ
;     255 /// ----------------------------------------------------------------------------
;     256 void Putsxyt(char x, char y,char dbuf[])
;     257 {
_Putsxyt:
;     258 	Gotoxyt(x,y);						// ǥ 
;	x -> Y+3
;	y -> Y+2
;	*dbuf -> Y+0
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	CALL _Gotoxyt
;     259 	Puts(dbuf);						// ڿ ǥ
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _Puts
;     260 }
	RJMP _0xB0
;     261 
;     262 // =======================  ġ flash ڿ ǥ =======================
;     263 // [μ] char x,char y,char flash dbuf[]
;     264 // Item1: ǥ xǥ(1-20)
;     265 // Item2: ǥ yǥ(1-4)
;     266 // Item3: ǥ ڿ
;     267 /// ----------------------------------------------------------------------------
;     268 void Putsxyt_f(char x, char y,char flash dbuf[])
;     269 {
_Putsxyt_f:
;     270 	Gotoxyt(x,y);						// ǥ 
;	x -> Y+5
;	y -> Y+4
;	*dbuf -> Y+0
	LDD  R30,Y+5
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	CALL _Gotoxyt
;     271 	while(*dbuf) LCD_Dwrite(*dbuf++);			// ڿ 
_0x13:
	CALL SUBOPT_0x0
	__GETBRPF 30
	CPI  R30,0
	BREQ _0x15
	CALL SUBOPT_0x1
;     272 }
	RJMP _0x13
_0x15:
	ADIW R28,6
	RET
;     273 
;     274 // ================================= LCD ʱȭ ===============================
;     275 // [μ] void
;     276 // ----------------------------------------------------------------------------
;     277 void LCD_Init(void)
;     278 {
_LCD_Init:
;     279 	delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CALL SUBOPT_0x2
;     280 	LCD_Command(0x38);
;     281 	delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0x2
;     282 	LCD_Command(0x38);
;     283 	delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	CALL SUBOPT_0x2
;     284 	LCD_Command(0x38);					// FUNCTION SET
;     285 	LCD_Command(0x0c);					// DISP ON/CURSOR/BLINK ON
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL _LCD_Command
;     286 	LCD_Command(0x06);					// ENTRY MODE
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _LCD_Command
;     287 
;     288 	LCD_Command(0x01);					// ALL CLEAR
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_Command
;     289 	delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     290 }
	RET
;     291 
;     292 // =================================== BUSY Check ============================
;     293 // [μ] void
;     294 // ---------------------------------------------------------------------------
;     295 void LCD_Busy(void)
;     296 {
_LCD_Busy:
;     297 unsigned char i,ch;
;     298 
;     299 	PORTA = 0xff;						// PORTA = PULL UP
	ST   -Y,R17
	ST   -Y,R16
;	i -> R17
;	ch -> R16
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     300 	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;     301 
;     302 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	CBI  0x3,4
;     303 	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	CBI  0x3,5
;     304 	PORTG |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read
	LDS  R30,101
	ORI  R30,1
	STS  101,R30
;     305 
;     306 	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	SBI  0x3,4
;     307 	for(i = 0; i < 3; i++);					// delay
	LDI  R17,LOW(0)
_0x17:
	CPI  R17,3
	BRSH _0x18
	SUBI R17,-1
	RJMP _0x17
_0x18:
;     308 	ch = PINA & 0x80;					// LCD DATA Read :: BUSY BIT
	IN   R30,0x19
	ANDI R30,LOW(0x80)
	MOV  R16,R30
;     309 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	CBI  0x3,4
;     310 	for(i = 0; i < 3; i++);
	LDI  R17,LOW(0)
_0x1A:
	CPI  R17,3
	BRSH _0x1B
	SUBI R17,-1
	RJMP _0x1A
_0x1B:
;     311 	while(ch == 0x80){
_0x1C:
	CPI  R16,128
	BRNE _0x1E
;     312 		PORTE |= 0x10;					// PORTE.4 :: LCD_E = 1
	SBI  0x3,4
;     313 		for(i = 0; i < 3; i++);
	LDI  R17,LOW(0)
_0x20:
	CPI  R17,3
	BRSH _0x21
	SUBI R17,-1
	RJMP _0x20
_0x21:
;     314 		ch = PINA & 0x80;				// LCD DATA Read :: BUSY BIT
	IN   R30,0x19
	ANDI R30,LOW(0x80)
	MOV  R16,R30
;     315 		PORTE &= 0xef;					// PORTE.4 :: LCD_E = 0
	CBI  0x3,4
;     316 		for(i = 0; i < 3; i++);
	LDI  R17,LOW(0)
_0x23:
	CPI  R17,3
	BRSH _0x24
	SUBI R17,-1
	RJMP _0x23
_0x24:
;     317 	}
	RJMP _0x1C
_0x1E:
;     318 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;     319 
;     320 // ============================== COMMAND  write =======================
;     321 // [μ] unsigned char uch
;     322 // Item1: 
;     323 // ---------------------------------------------------------------------------
;     324 void LCD_Command(unsigned char uch)
;     325 {
_LCD_Command:
;     326 int i;
;     327 
;     328 	LCD_Busy();						// BUSY Check
	CALL SUBOPT_0x3
;	uch -> Y+2
;	i -> R16,R17
;     329 	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set
;     330 
;     331 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
;     332 	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	CBI  0x3,5
;     333 	PORTG &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write
	CALL SUBOPT_0x4
;     334 	PORTA = uch;						// PORTA = uch
;     335 	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
;     336 	for(i = 0; i < 3; i++);
_0x26:
	__CPWRN 16,17,3
	BRGE _0x27
	__ADDWRN 16,17,1
	RJMP _0x26
_0x27:
;     337 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	CBI  0x3,4
;     338 	for(i = 0; i < 3; i++);					// delay
	__GETWRN 16,17,0
_0x29:
	__CPWRN 16,17,3
	BRGE _0x2A
	__ADDWRN 16,17,1
	RJMP _0x29
_0x2A:
;     339 }
	RJMP _0xB1
;     340 
;     341 // ===================================  write ==========================
;     342 // [μ] unsigned char uch
;     343 // Item1: 
;     344 // ---------------------------------------------------------------------------
;     345 void LCD_Dwrite(unsigned char uch)
;     346 {
_LCD_Dwrite:
;     347 int i;
;     348 
;     349 	LCD_Busy();						// BUSY Check
	CALL SUBOPT_0x3
;	uch -> Y+2
;	i -> R16,R17
;     350 	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set
;     351 
;     352 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
;     353 	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	SBI  0x3,5
;     354 	PORTG &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write
	CALL SUBOPT_0x4
;     355 	PORTA = uch;						// PORTA = uch
;     356 	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
;     357 	for(i = 0; i < 3; i++);
_0x2C:
	__CPWRN 16,17,3
	BRGE _0x2D
	__ADDWRN 16,17,1
	RJMP _0x2C
_0x2D:
;     358 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	CBI  0x3,4
;     359 	for(i = 0; i < 3; i++);					// delay
	__GETWRN 16,17,0
_0x2F:
	__CPWRN 16,17,3
	BRGE _0x30
	__ADDWRN 16,17,1
	RJMP _0x2F
_0x30:
;     360 }
_0xB1:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,3
	RET
;     361 
;     362 // ===================================  read ===========================
;     363 // [μ] void
;     364 // [] (0-0xff)
;     365 // ---------------------------------------------------------------------------
;     366 unsigned char LCD_Dread(void)
;     367 {
;     368 unsigned char i,uch;
;     369 
;     370 	LCD_Busy();						// BUSY Check
;	i -> R17
;	uch -> R16
;     371 	PORTA = 0xff;						// PORTA = PULL UP
;     372 	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set
;     373 
;     374 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
;     375 	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
;     376 	PORTG |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read
;     377 
;     378 	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
;     379 	for(i = 0; i < 5; i++);					// delay
;     380 	uch = PINA & 0xff;					// LCD DATA Read :: BUSY BIT
;     381 	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
;     382 	for(i = 0; i < 3; i++);
;     383 	return(uch);						//  read
;     384 }
;     385 
;     386 // Լ 
;     387 void main_menu_disp(void);						//  ޴ ǥ
;     388 
;     389 //  
;     390 
;     391 // ===============================  α׷ ==============================
;     392 // [μ]: void
;     393 // ---------------------------------------------------------------------------
;     394 int main(void)
;     395 {
_main:
;     396 char lcd_buf[25];
;     397 
;     398 	cpu_setup();							// cpu ʱȭ
	SBIW R28,25
;	lcd_buf -> Y+0
	CALL _cpu_setup
;     399 	LCD_Init();							// LCD ʱȭ
	CALL _LCD_Init
;     400 	main_menu_disp();						//  ޴ ǥ
	RCALL _main_menu_disp
;     401 	Putsxyt_f(1,1,"  MEGA128_Clcd  ");
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	__POINTD1FN _0,0
	CALL SUBOPT_0x5
;     402 	Putsxyt_f(1,2,"www.cpuplaza.com");
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	__POINTD1FN _0,17
	CALL SUBOPT_0x5
;     403 	while(1){
_0x37:
;     404 		if(com1_rx_eflg){					// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0x3A
;     405 			if(com1_rx_data == '1') Clrscr();		// ȭ 
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x3B
	CALL _Clrscr
;     406 			else if(com1_rx_data == '2') Putch('1');	// 1 ǥ
	RJMP _0x3C
_0x3B:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0x3D
	LDI  R30,LOW(49)
	ST   -Y,R30
	CALL _Putch
;     407 			else if(com1_rx_data == '3') Putchxyt(1,1,'3');	// ؽƮ ǥ 1 ǥ
	RJMP _0x3E
_0x3D:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0x3F
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R30,LOW(51)
	ST   -Y,R30
	CALL _Putchxyt
;     408 			else if(com1_rx_data == '4'){
	RJMP _0x40
_0x3F:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0x41
;     409 				sprintf(lcd_buf,"123");			// ǥ ڿ
	CALL SUBOPT_0x6
	__POINTD1FN _0,34
	CALL SUBOPT_0x7
;     410 				Puts(lcd_buf);
	CALL SUBOPT_0x6
	CALL _Puts
;     411 			}
;     412 			else if(com1_rx_data == '5'){			// ؽƮ ǥ ڿ ǥ
	RJMP _0x42
_0x41:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x43
;     413 				sprintf(lcd_buf,"LCD TEST LINE1");	// ǥ ڿ
	CALL SUBOPT_0x6
	__POINTD1FN _0,38
	CALL SUBOPT_0x7
;     414 				Putsxyt(4,1,lcd_buf);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(1)
	CALL SUBOPT_0x8
;     415 				sprintf(lcd_buf,"LCD TEST LINE2");	// ǥ ڿ
	__POINTD1FN _0,53
	CALL SUBOPT_0x7
;     416 				Putsxyt(4,2,lcd_buf);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(2)
	CALL SUBOPT_0x8
;     417 				sprintf(lcd_buf,"LCD TEST LINE3");	// ǥ ڿ
	__POINTD1FN _0,68
	CALL SUBOPT_0x7
;     418 				Putsxyt(4,3,lcd_buf);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(3)
	CALL SUBOPT_0x8
;     419 				sprintf(lcd_buf,"LCD TEST LINE4");	// ǥ ڿ
	__POINTD1FN _0,83
	CALL SUBOPT_0x7
;     420 				Putsxyt(4,4,lcd_buf);
	LDI  R30,LOW(4)
	ST   -Y,R30
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putsxyt
;     421 			}
;     422 			else if(com1_rx_data == '6') Puts_f("123");	// ǥ ڿ(FLASH)
	RJMP _0x44
_0x43:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0x45
	__POINTD1FN _0,34
	CALL __PUTPARD1
	CALL _Puts_f
;     423 			else if(com1_rx_data == '7'){			// ؽƮ ǥ ڿ(FLASH) ǥ
	RJMP _0x46
_0x45:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0x47
;     424 				Putsxyt_f(4,1,"LCD TEST LINE1");
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__POINTD1FN _0,38
	CALL SUBOPT_0x5
;     425 				Putsxyt_f(4,2,"LCD TEST LINE2");
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	__POINTD1FN _0,53
	CALL SUBOPT_0x5
;     426 				Putsxyt_f(4,3,"LCD TEST LINE3");
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	__POINTD1FN _0,68
	CALL SUBOPT_0x5
;     427 				Putsxyt_f(4,4,"LCD TEST LINE4");
	LDI  R30,LOW(4)
	ST   -Y,R30
	ST   -Y,R30
	__POINTD1FN _0,83
	CALL SUBOPT_0x5
;     428 			}
;     429 			else if(com1_rx_data == '8') Cursor_Set(ON);	// Ŀ ON
	RJMP _0x48
_0x47:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0x49
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _Cursor_Set
;     430 			else if(com1_rx_data == '9') Cursor_Set(OFF);	// Ŀ OFF
	RJMP _0x4A
_0x49:
	LDI  R30,LOW(57)
	CP   R30,R5
	BRNE _0x4B
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _Cursor_Set
;     431 			else putchar(com1_rx_data);
	RJMP _0x4C
_0x4B:
	ST   -Y,R5
	CALL _putchar
;     432 			com1_rx_eflg = 0;
_0x4C:
_0x4A:
_0x48:
_0x46:
_0x44:
_0x42:
_0x40:
_0x3E:
_0x3C:
	CLR  R4
;     433 		}
;     434 	}
_0x3A:
	RJMP _0x37
;     435 	return 0;
_0x4D:
	RJMP _0x4D
;     436 }
;     437 
;     438 // =====================================  ޴ ǥ =======================
;     439 // [μ] void
;     440 // ---------------------------------------------------------------------------
;     441 void main_menu_disp(void)
;     442 {
_main_menu_disp:
;     443 	printf("\r\n");
	__POINTD1FN _0,98
	CALL SUBOPT_0x9
;     444 	printf("========== LCD Test Main =========\r\n");
	__POINTD1FN _0,101
	CALL SUBOPT_0x9
;     445 	printf("- 1 : Clrscr                     -\r\n");
	__POINTD1FN _0,138
	CALL SUBOPT_0x9
;     446 	printf("- 2 : Putch                      -\r\n");
	__POINTD1FN _0,175
	CALL SUBOPT_0x9
;     447 	printf("- 3 : Putchxyt                   -\r\n");
	__POINTD1FN _0,212
	CALL SUBOPT_0x9
;     448 	printf("- 4 : Puts                       -\r\n");
	__POINTD1FN _0,249
	CALL SUBOPT_0x9
;     449 	printf("- 5 : Putsxyt                    -\r\n");
	__POINTD1FN _0,286
	CALL SUBOPT_0x9
;     450 	printf("- 6 : Puts_f                     -\r\n");
	__POINTD1FN _0,323
	CALL SUBOPT_0x9
;     451 	printf("- 7 : Putsxyt_f                  -\r\n");
	__POINTD1FN _0,360
	CALL SUBOPT_0x9
;     452 	printf("- 8 : Cursor ON                  -\r\n");
	__POINTD1FN _0,397
	CALL SUBOPT_0x9
;     453 	printf("- 9 : Cursor OFF                 -\r\n");
	__POINTD1FN _0,434
	CALL SUBOPT_0x9
;     454 	printf("----------------------------------\r\n");
	__POINTD1FN _0,471
	CALL __PUTPARD1
	LDI  R24,0
	CALL _printf
_0xB0:
	ADIW R28,4
;     455 }
	RET
;     456 

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x4E
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x50
	__CPWRN 16,17,2
	BRLO _0x51
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x50:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x51:
	RJMP _0x52
_0x4E:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x52:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,8
	CALL __SAVELOCR6
	LDI  R17,0
_0x53:
	__GETD1S 20
	__SUBD1N -1
	__PUTD1S 20
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__GETBRPF 30
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x55
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x59
	CPI  R18,37
	BRNE _0x5A
	LDI  R17,LOW(1)
	RJMP _0x5B
_0x5A:
	CALL SUBOPT_0xA
_0x5B:
	RJMP _0x58
_0x59:
	CPI  R30,LOW(0x1)
	BRNE _0x5C
	CPI  R18,37
	BRNE _0x5D
	CALL SUBOPT_0xA
	RJMP _0xB5
_0x5D:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x5E
	LDI  R16,LOW(1)
	RJMP _0x58
_0x5E:
	CPI  R18,43
	BRNE _0x5F
	LDI  R20,LOW(43)
	RJMP _0x58
_0x5F:
	CPI  R18,32
	BRNE _0x60
	LDI  R20,LOW(32)
	RJMP _0x58
_0x60:
	RJMP _0x61
_0x5C:
	CPI  R30,LOW(0x2)
	BRNE _0x62
_0x61:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x63
	ORI  R16,LOW(128)
	RJMP _0x58
_0x63:
	RJMP _0x64
_0x62:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x58
_0x64:
	CPI  R18,48
	BRLO _0x67
	CPI  R18,58
	BRLO _0x68
_0x67:
	RJMP _0x66
_0x68:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x58
_0x66:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x6C
	CALL SUBOPT_0xB
	LD   R30,X
	CALL SUBOPT_0xC
	RJMP _0x6D
_0x6C:
	CPI  R30,LOW(0x73)
	BRNE _0x6F
	CALL SUBOPT_0xB
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x70
_0x6F:
	CPI  R30,LOW(0x70)
	BRNE _0x72
	CALL SUBOPT_0xB
	CALL __GETD1P
	CALL SUBOPT_0xD
	CALL SUBOPT_0xE
	CALL __PUTPARD1
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x70:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x73
_0x72:
	CPI  R30,LOW(0x64)
	BREQ _0x76
	CPI  R30,LOW(0x69)
	BRNE _0x77
_0x76:
	ORI  R16,LOW(4)
	RJMP _0x78
_0x77:
	CPI  R30,LOW(0x75)
	BRNE _0x79
_0x78:
	__POINTD1FN _tbl10_G2,0
	CALL SUBOPT_0xD
	LDI  R17,LOW(5)
	RJMP _0x7A
_0x79:
	CPI  R30,LOW(0x58)
	BRNE _0x7C
	ORI  R16,LOW(8)
	RJMP _0x7D
_0x7C:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0xAE
_0x7D:
	__POINTD1FN _tbl16_G2,0
	CALL SUBOPT_0xD
	LDI  R17,LOW(4)
_0x7A:
	SBRS R16,2
	RJMP _0x7F
	CALL SUBOPT_0xB
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,0
	BRGE _0x80
	CALL __ANEGW1
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDI  R20,LOW(45)
_0x80:
	CPI  R20,0
	BREQ _0x81
	SUBI R17,-LOW(1)
	RJMP _0x82
_0x81:
	ANDI R16,LOW(251)
_0x82:
	RJMP _0x83
_0x7F:
	CALL SUBOPT_0xB
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
_0x83:
_0x73:
	SBRC R16,0
	RJMP _0x84
_0x85:
	CP   R17,R21
	BRSH _0x87
	SBRS R16,7
	RJMP _0x88
	SBRS R16,2
	RJMP _0x89
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x8A
_0x89:
	LDI  R18,LOW(48)
_0x8A:
	RJMP _0x8B
_0x88:
	LDI  R18,LOW(32)
_0x8B:
	CALL SUBOPT_0xA
	SUBI R21,LOW(1)
	RJMP _0x85
_0x87:
_0x84:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x8C
_0x8D:
	CPI  R19,0
	BREQ _0x8F
	SBRS R16,3
	RJMP _0x90
	CALL SUBOPT_0xE
	__SUBD1N -1
	CALL SUBOPT_0xD
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__GETBRPF 30
	RJMP _0xB6
_0x90:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xB6:
	ST   -Y,R30
	CALL SUBOPT_0xF
	CPI  R21,0
	BREQ _0x92
	SUBI R21,LOW(1)
_0x92:
	SUBI R19,LOW(1)
	RJMP _0x8D
_0x8F:
	RJMP _0x93
_0x8C:
_0x95:
	LDI  R18,LOW(48)
	CALL SUBOPT_0xE
	__SUBD1N -2
	CALL SUBOPT_0xD
	SBIW R30,2
	SBCI R22,0
	SBCI R23,0
	CALL __GETW1PF
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x97:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x99
	SUBI R18,-LOW(1)
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
	RJMP _0x97
_0x99:
	CPI  R18,58
	BRLO _0x9A
	SBRS R16,3
	RJMP _0x9B
	SUBI R18,-LOW(7)
	RJMP _0x9C
_0x9B:
	SUBI R18,-LOW(39)
_0x9C:
_0x9A:
	SBRC R16,4
	RJMP _0x9E
	CPI  R18,49
	BRSH _0xA0
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,1
	BRNE _0x9F
_0xA0:
	RJMP _0xB7
_0x9F:
	CP   R21,R19
	BRLO _0xA4
	SBRS R16,0
	RJMP _0xA5
_0xA4:
	RJMP _0xA3
_0xA5:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0xA6
	LDI  R18,LOW(48)
_0xB7:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0xA7
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0xF
	CPI  R21,0
	BREQ _0xA8
	SUBI R21,LOW(1)
_0xA8:
_0xA7:
_0xA6:
_0x9E:
	CALL SUBOPT_0xA
	CPI  R21,0
	BREQ _0xA9
	SUBI R21,LOW(1)
_0xA9:
_0xA3:
	SUBI R19,LOW(1)
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,2
	BRLO _0x96
	RJMP _0x95
_0x96:
_0x93:
	SBRS R16,0
	RJMP _0xAA
_0xAB:
	CPI  R21,0
	BREQ _0xAD
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0xC
	RJMP _0xAB
_0xAD:
_0xAA:
_0xAE:
_0x6D:
_0xB5:
	LDI  R17,LOW(0)
_0x58:
	RJMP _0x53
_0x55:
	CALL __LOADLOCR6
	ADIW R28,24
	RET
_sprintf:
	PUSH R15
	CALL SUBOPT_0x10
	MOVW R26,R28
	ADIW R26,8
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	CALL SUBOPT_0x11
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0xAF
_printf:
	PUSH R15
	CALL SUBOPT_0x10
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	CALL SUBOPT_0x11
_0xAF:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	__GETD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1:
	RCALL SUBOPT_0x0
	__SUBD1N -1
	__PUTD1S 0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__GETBRPF 30
	ST   -Y,R30
	JMP  _LCD_Dwrite

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(56)
	ST   -Y,R30
	JMP  _LCD_Command

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	ST   -Y,R17
	ST   -Y,R16
	CALL _LCD_Busy
	LDI  R30,LOW(255)
	OUT  0x1A,R30
	CBI  0x3,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	LDS  R30,101
	ANDI R30,0xFE
	STS  101,R30
	LDD  R30,Y+2
	OUT  0x1B,R30
	SBI  0x3,4
	__GETWRN 16,17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5:
	CALL __PUTPARD1
	JMP  _Putsxyt_f

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7:
	CALL __PUTPARD1
	LDI  R24,0
	CALL _sprintf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x8:
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putsxyt
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x9:
	CALL __PUTPARD1
	LDI  R24,0
	CALL _printf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0xA:
	ST   -Y,R18
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xB:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SBIW R26,4
	STD  Y+18,R26
	STD  Y+18+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	__PUTD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	__GETD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xF:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x11:
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETD1P
	CALL __PUTPARD1
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	JMP  __print_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
	ld   r22,y+
	ld   r23,y+
	out  rampz,r22
__strlenf0:
	elpm r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETW1PF:
	OUT  RAMPZ,R22
	ELPM R0,Z+
	ELPM R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
