// ======================== Atmega128 ؽƮ LCD α׷ =====================
//  CPU : ATmega128-16M - ؽƮ LCD(4*20)
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/* CodeVisionAVR C Compiler
   (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L. */






/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


//  
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   


// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortA 
// LCD_D[0..7] : LCD Data Bus
	PORTA=0xff;						// Ʈ  reg             
	DDRA=0x00;                                              // Ʈ  reg(0Է,1)

// PortC 
// LCD_D[8..15] : LCD Data Bus(color lcd)
// PortC.0 : LCD_CS1
// PortC.1 : LCD_CS2
	PORTC=0xfc;						// Ʈ  reg             
	DDRC=0x03;                                              // Ʈ  reg(0Է,1)

// PortE 
// PortE.3(OUT) : LCD DIR
// PortE.4(OUT) : LCD E
// PortE.5(OUT) : LCD RS
// PortE.6(OUT) : GLCD/CLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external) 
	PORTE=0x40;						// Ʈ  reg             
	DDRE=0x78;                                              // Ʈ  reg(0Է,1)

// PortG 
// PortG.0(OUT) : LCD R/W,CLCD_WR
// PortG.1(OUT) : LCD RD
// PortG.2(OUT) : LCD CS
	(*(unsigned char *) 0x65)=0x07;						// Ʈ  reg             
	(*(unsigned char *) 0x64)=0x07;                                              // Ʈ  reg(0Է,1)

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	(*(unsigned char *) 0x95)=0x06;
	(*(unsigned char *) 0x90)=0x00;
	UBRR0L=0x33;

// External SRAM page configuration: 
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
//	MCUCR=0xc0;
//	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [19] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ============================ ؽƮ LCD  α׷ ======================
//      : 4*20 LCD
// ----------------------------------------------------------------------------
// LCD  


// Լ 
void Clrscr(void);						// ȭ 

void Cursor_Set(char sts);					// Ŀ  
void Gotoxyt(char x, char y);					// ؽƮ ǥ

void Putch(char data);						// 1 ǥ
void Putchxyt(char x, char y,char data);			// ؽƮ ǥ  ǥ

// SRAM  ǥ 
void Puts(char stbuf[]);					// LCD ڿ 		
void Putsxyt(char x, char y,char dbuf[]);			// ؽƮ ǥ ڿ ǥ
// FLASH ޸ ڿ ǥ
void Puts_f(char flash stbuf[]);				// LCD ڿ(FLASH) 		
void Putsxyt_f(char x, char y,char flash dbuf[]);		// ؽƮ ǥ ڿ(FLASH) ǥ

void LCD_Init(void);						// GLCD Init
void LCD_Busy(void);						// LCD Busy Check
void LCD_Command(unsigned char uch);				// COMMAND Write
void LCD_Dwrite(unsigned char uch);				// DATA Write
unsigned char LCD_Dread(void);					// DATA 

//  

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char sts
// Item1: Ŀ (0,(OFF),1(ON))
// Item2: Ŀ ǥ ġ(SCREEN0,SCREEN1)
/// ----------------------------------------------------------------------------
void Cursor_Set(char sts)
{
	if(sts == 0) LCD_Command(0x0c);			// CURSOR OFF/BLINK OFF
	else LCD_Command(0x0f);					// CURSOR ON/BLINK ON(0x0e)
}

// ================================ ȭ Ұ ==================================
// [μ] void
/// ----------------------------------------------------------------------------
void Clrscr(void)
{
	LCD_Command(0x01);					// ALL CLEAR
}

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char x,char y
// Item1: ǥ xǥ(1-20)
// Item2: ǥ yǥ(1-4)
/// ----------------------------------------------------------------------------
void Gotoxyt(char x, char y)
{
char xx = x-1,yy = y-1;

	LCD_Busy();
	switch(yy){
		case 0: LCD_Command(0x80+xx); break;  
		case 1: LCD_Command(0xc0+xx); break;
		case 2: LCD_Command(0x94+xx); break;
		case 3: LCD_Command(0xd4+xx); break;	
	}
}

// ==================================  ǥ ================================
// [μ] char data
// Item1: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putch(char data)
{
	LCD_Dwrite(data);					//  ǥ
}

// ============================  ġ  ǥ ===========================
// [μ] char x,char y,char data
// Item1: ǥ xǥ(1-20)
// Item2: ǥ yǥ(1-4)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putchxyt(char x, char y,char data)
{
	Gotoxyt(x,y);						// ǥ 
	LCD_Dwrite(data);					//  ǥ
}

// ============================= LCD1 ڿ  ===========================
// [μ] char str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts(char stbuf[])
{
char *pstr = 0;

	pstr = stbuf;
	while(*pstr) LCD_Dwrite(*pstr++);			// ڿ 
}

// ========================== LCD1 FLASH ڿ  ========================
// [μ] char flash str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts_f(char flash stbuf[])
{
	while(*stbuf) LCD_Dwrite(*stbuf++);			// ڿ 
}

// ===========================  ġ ڿ ǥ =========================
// [μ] char x,char y,char dbuf[]
// Item1: ǥ xǥ(1-20)
// Item2: ǥ yǥ(1-4)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt(char x, char y,char dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	Puts(dbuf);						// ڿ ǥ
}

// =======================  ġ flash ڿ ǥ =======================
// [μ] char x,char y,char flash dbuf[]
// Item1: ǥ xǥ(1-20)
// Item2: ǥ yǥ(1-4)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt_f(char x, char y,char flash dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	while(*dbuf) LCD_Dwrite(*dbuf++);			// ڿ 
}

// ================================= LCD ʱȭ ===============================
// [μ] void
// ----------------------------------------------------------------------------
void LCD_Init(void)
{
	delay_ms(50);
	LCD_Command(0x38);
	delay_ms(100);
	LCD_Command(0x38);
	delay_ms(200);
	LCD_Command(0x38);					// FUNCTION SET
	LCD_Command(0x0c);					// DISP ON/CURSOR/BLINK ON
	LCD_Command(0x06);					// ENTRY MODE
	
	LCD_Command(0x01);					// ALL CLEAR
	delay_ms(100);
}

// =================================== BUSY Check ============================
// [μ] void
// ---------------------------------------------------------------------------
void LCD_Busy(void)
{
unsigned char i,ch;

	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	(*(unsigned char *) 0x65) |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);					// delay
	ch = PINA & 0x80;					// LCD DATA Read :: BUSY BIT
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);	
	while(ch == 0x80){
		PORTE |= 0x10;					// PORTE.4 :: LCD_E = 1
		for(i = 0; i < 3; i++);	
		ch = PINA & 0x80;				// LCD DATA Read :: BUSY BIT
		PORTE &= 0xef;					// PORTE.4 :: LCD_E = 0
		for(i = 0; i < 3; i++);	
	}
}

// ============================== COMMAND  write =======================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Command(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	(*(unsigned char *) 0x65) &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write	
	PORTA = uch;						// PORTA = uch
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  write ==========================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Dwrite(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	(*(unsigned char *) 0x65) &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write	
	PORTA = uch;						// PORTA = uch
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  read ===========================
// [μ] void
// [] (0-0xff)
// ---------------------------------------------------------------------------
unsigned char LCD_Dread(void)
{
unsigned char i,uch;

	LCD_Busy();						// BUSY Check
	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	(*(unsigned char *) 0x65) |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 5; i++);					// delay
	uch = PINA & 0xff;					// LCD DATA Read :: BUSY BIT
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);	
	return(uch);						//  read
}

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char lcd_buf[25];
	
	cpu_setup();							// cpu ʱȭ
	LCD_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt_f(1,1,"  MEGA128_Clcd  ");
	Putsxyt_f(1,2,"www.cpuplaza.com");
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '3') Putchxyt(1,1,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '4'){
				sprintf(lcd_buf,"123");			// ǥ ڿ
				Puts(lcd_buf);
			}
			else if(com1_rx_data == '5'){			// ؽƮ ǥ ڿ ǥ
				sprintf(lcd_buf,"LCD TEST LINE1");	// ǥ ڿ
				Putsxyt(4,1,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE2");	// ǥ ڿ
				Putsxyt(4,2,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE3");	// ǥ ڿ
				Putsxyt(4,3,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE4");	// ǥ ڿ
				Putsxyt(4,4,lcd_buf);
			}
			else if(com1_rx_data == '6') Puts_f("123");	// ǥ ڿ(FLASH)
			else if(com1_rx_data == '7'){			// ؽƮ ǥ ڿ(FLASH) ǥ
				Putsxyt_f(4,1,"LCD TEST LINE1");
				Putsxyt_f(4,2,"LCD TEST LINE2");
				Putsxyt_f(4,3,"LCD TEST LINE3");
				Putsxyt_f(4,4,"LCD TEST LINE4");
			}
			else if(com1_rx_data == '8') Cursor_Set(1);	// Ŀ ON
			else if(com1_rx_data == '9') Cursor_Set(0);	// Ŀ OFF
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========== LCD Test Main =========\r\n");
	printf("- 1 : Clrscr                     -\r\n");
	printf("- 2 : Putch                      -\r\n");
	printf("- 3 : Putchxyt                   -\r\n");
	printf("- 4 : Puts                       -\r\n");
	printf("- 5 : Putsxyt                    -\r\n");
	printf("- 6 : Puts_f                     -\r\n");
	printf("- 7 : Putsxyt_f                  -\r\n");
	printf("- 8 : Cursor ON                  -\r\n");
	printf("- 9 : Cursor OFF                 -\r\n");
	printf("----------------------------------\r\n");
}

